<?

/*
 * php-booba - simple PHP web application network
 * Copyright (C) 2004  Marcin Gajda
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

class DB
{
	var $conn;

	function polacz()
	{
		if( $this->conn )
			$this->odlacz();

		$config = getConfig();

		$dbConfig = $config->getParameterValue( 'DB' );

		$this->conn = pg_connect(
			'dbname='.$dbConfig[ 'dbname' ].' '
			.'host='.$dbConfig[ 'host' ].' '
			.'port='.$dbConfig[ 'port' ].' '
			.'user='.$dbConfig[ 'user' ].' '
			.'password='.$dbConfig[ 'password' ] );

		if( !$this->conn )
			return false;

		return true;
	}
	
	function odlacz()
	{
		if( $this->conn == NULL )
			return;

		pg_close( $this->conn );

		$this->conn = NULL;
	}

	function query( $query )
	{
		if( $this->conn == NULL )
			return NULL;

		$result = pg_exec( $this->conn , $query );

		$wynik = array();
		$ile_wierszy = pg_numrows( $result );

		for( $i=0; $i<$ile_wierszy; $i++ )
			array_push( $wynik , pg_fetch_array( $result , $i , PGSQL_ASSOC ) );

		pg_freeresult( $result );

		return $wynik;
	}

	function quote( $string )
	{
		return pg_escape_string( $string );
	}
}

function &getDB()
{
	global $_CMS_DB;

	if( !is_object( $_CMS_DB ) )
	{
		$_CMS_DB = new DB();

		$_CMS_DB->polacz();
	}

	return $_CMS_DB;
}

?>
